#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include "/musr/cmix/sys/mixerr.h"
#include "/musr/cmix/rtstuff/Instrument.h"
#include "OSCIL.h"
#include "/musr/cmix/rtstuff/rt.h"
#include "/musr/cmix/rtstuff/rtdefs.h"


extern "C" {
	#include "/musr/cmix/H/ugens.h"
	extern int resetval;
}

OSCIL::OSCIL() : Instrument()
{
	// future setup here?
}

int OSCIL::init(float p[], short n_args)
{
// p0 = start, p1 = duration, p2 = amplitude, p3 = frequency
// assumes that makegen slot 1 is the waveform to oscillate

	nsamps = rtsetoutput(p[0], p[1], this); // rtsetoutput takes a start
				// time in seconds, a duration in seconds,
				// and finally a pointer (C++) to this
				// particular instrument/note

	amp = p[2];

	wavetable = floc(1);	// floc() finds where the makegen(1, 10, ...)
				// waveform is stored

	len = fsize(1);		// fsize() returns the length of that makegen

	phase = 0.0;		// initialize the phase to 0

	si = p[3] * (float)len/SR; // the MAGIC formula for the sampling
				// increment: si = frequency * (length/SR)

	return(nsamps);
}

int OSCIL::run()
{
	int i;
	float out[2];

	for (i = 0; i < chunksamps; i++) {

// oscil(amp, si, wavetable, len, &phase)
// amp = amplitude
// si = sampling increment
// wavetable = pointer to the makegen function with the waveform
// len = the length of that function
// phase = a variable you declare as float in the "OSCIL.h" file
//    which keeps track of where the oscillator is in the waveform
//
		out[0] = oscil(amp, si, wavetable, len, &phase);
		rtaddout(out);
		cursamp++;
		}
	return(i);
}



Instrument*
makeOSCIL()
{
	OSCIL *inst;

	inst = new OSCIL();
	return inst;
}

void
rtprofile()
{
	RT_INTRO("OSCIL",makeOSCIL);
}

